/*-------------------------------------------------------------------------+
| Copyright 2024 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.ext.quality.service;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.ext.quality.data.MetricTreeNode;
import org.fortiss.tooling.kernel.service.base.IEObjectAware;

/**
 * Interface for all metric providers.
 * They are called by {@link IModelQualityService} to collect metrics on model elements.
 * 
 * @author blaschke
 */
public interface IMetricProvider<C extends EObject> extends IEObjectAware<EObject> {

	/** Applies the IMetricProvider to the given model element. */
	void collectMetrics(MetricTreeNode node, C element);
}
